import random
import time
from decimal import Decimal
from linear_search import linear_search
from binary_search import binary_search

# generate list of 100 Million elements, 
# where each element is a random number between 0 and 100,000,000
print("Generating list...")
n = 10**7
L = random.sample(range(10**9), n)

print("Sorting list...")
L.sort()

key = int(input("Enter key for linear search: "))

# perform linear search
print("Starting linear search ...")
time_start = time.time()
index = linear_search(L, key)
time_finish = time.time()
linear_search_time = time_finish-time_start
print(f"Found at position: {index}; time taken: {linear_search_time:.2f} seconds")

print("Starting binary search ...")
time_start = time.time()
index = binary_search(L, key)
time_finish = time.time()
binary_search_time = time_finish-time_start
print(f"Found at position: {index}; time taken:", "{:.2e}".format(binary_search_time), "seconds")

print(f"Binary_search is {linear_search_time/binary_search_time:.0f} faster than linear_search")

